﻿Type=Service
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes1
    #StartAtBoot: True
#End Region

Sub Process_Globals
    '--- These global variables will be declared once when the application starts.
    '--- These variables can be accessed from all modules.
    Private tmrStart As Timer
	Type Renglones (Renglon1 As String, Renglon2 As String)
	Dim UltimoRegistro,NuevoRegistro As Int
	Dim PrimeraVez As Boolean
	Dim N As Notification
	Dim Tiempo,Activado As String
	Dim nNotify As Notification   
End Sub


Sub Globals

End Sub



Sub GetData(SQL_Cadena As String, sJob As String)
    Dim GetSQL As HttpJob
    GetSQL.Initialize(sJob, Me)
	GetSQL.download2("http://xxxxx.php", Array As String ("SQL", SQL_Cadena))  
End Sub

Sub User_PHP
	If PrimeraVez Then
    	GetData("SELECT * FROM listadocambios WHERE Activo ='S' ORDER BY Num","GetResultado")
	Else
		GetData("SELECT * FROM listadocambios WHERE Activo ='S' and Num > '"&UltimoRegistro&"' ORDER BY Num","GetResultado")
	End If
End Sub


Sub tmrStart_Tick
	If Activado = "S" Then User_PHP
    tmrStart.Interval=(Tiempo*60)*1000
End Sub


Sub DameFormatoSpain(FechaIng As String) As String
	Dim S As String
	S = FechaIng.SubString2(8,10) & "/" & FechaIng.SubString2(5,7) & "/" & FechaIng.SubString2(0,4)
	Return (S)
End Sub


Sub JobDone(Job As HttpJob)
    If Job.Success Then
        Dim res As String
        res = Job.GetString
	    If res.StartsWith("{") Or res.StartsWith("[") Then 
	        Log("Back from Job:" & Job.JobName )
	        Log("Job Text: " & res)
	        Dim parser As JSONParser
	        parser.Initialize(res)	
	        Select Job.JobName
	            Case "GetResultado"
	               Dim ListaDatos As List
	                 ListaDatos = parser.NextArray 'returns a list with maps
	                If ListaDatos.Size == 0 Then
	                   'Algun mensaje.
	                Else     						
						If PrimeraVez Then
							For i = 0 To ListaDatos.Size - 1
			                	Dim Datos As Map
			                    Datos = ListaDatos.Get(i)
								UltimoRegistro = Datos.Get("Num")
							Next
							PrimeraVez = False
						Else
							Dim notificacion As Notification
							notificacion.Initialize
							notificacion.Icon = "icon"		
							Dim Datos As Map
							For i = 0 To ListaDatos.Size - 1
								Datos = ListaDatos.Get(i)		
								NuevoRegistro = Datos.Get("Num")
								'Num	FechaBorrado	IDCreador	FechaCreacion	FechaCambio	Servicio	EsDe	Quiero	Notas	Quien	Activo
								If NuevoRegistro > UltimoRegistro Then
									UltimoRegistro = NuevoRegistro
									n.Vibrate = False
									n.Sound = False
									n.SetInfo(DameFormatoSpain(Datos.Get("FechaCambio"))&" Serv. "&Datos.Get("Servicio"),Datos.Get("EsDe")&"x"&Datos.Get("Quiero")&" ("&Datos.Get("Quien")&")", Me)
									n.Notify(i)
								End If
							Next
						End If						
'	                    s.TransactionSuccessful
'	                    s.EndTransaction
'	                    s.Close
	                End If
	        End Select
	    Else
	    'alguna condicion
	    End If
    Else
        'ToastMessageShow("Error: " & Job.ErrorMessage, True)
    End If
    Job.Release
End Sub

Sub Service_Create
    '--- set timer to start app after 1 seconds (1 seg = 1000 milisegundos)
	'--- this gives time for system to init other stuff
	
	
'	nNotify.Initialize
'	nNotify.Icon = "icon"
'	nNotify.Vibrate=False
'	nNotify.SetInfo2("MyService","Service Running","...",Main)
'	nNotify.Sound = False
'	nNotify.Notify(1)
'	Service.StartForeground(1,nNotify)
'	PrimeraVez = True
'	UltimoRegistro = 0
	
	
	'MI VERSION
	nNotify.Initialize
	nNotify.Icon = "trasp"
	Service.StartForeground(1,nNotify)
	PrimeraVez = True
	UltimoRegistro = 0
	n.Initialize
	n.Icon = "icon"
	' MI VERSION

	If File.Exists(File.DirDefaultExternal,"l4n.dat") = False Then
		'****** for Write txt  or etc file for string******************
		Dim TW As TextWriter
		TW.Initialize(File.OpenOutput(File.DirDefaultExternal,"l4n.dat",False))
		TW.WriteLinE("S")
		TW.Writeline("30")
		TW.Close
		Activado = "S"
		Tiempo = "5"
	Else
		'****** for Read txt  or etc file for string******************			
		Dim TR As TextReader
		TR.Initialize(File.OpenInput(File.DirDefaultExternal,"l4n.dat"))
		Activado = TR.ReadLine
		Tiempo = TR.ReadLINE
		TR.Close
	End If
	tmrStart.Initialize("tmrStart",(Tiempo * 60) * 1000)
End Sub

Sub Service_Start (StartingIntent As Intent)
    '--- enabled timer
    tmrStart.Enabled = True
End Sub

Private Sub Service_Destroy

End Sub